#define enA  3
#define Ain1  2
#define Ain2  4

#define enB  6
#define Bin1  5
#define Bin2  7

#define trig 13
#define echo 10

#define RECEIVER 9

#include <Servo.h>
#include "Wire.h"       
#include "I2Cdev.h"     
#include "MPU6050.h"   

#include "IRremote.h"
#include "IR.h" 

IRrecv IR(RECEIVER);
decode_results results;

const int MPU_addr=0x68; int16_t AcX,AcY,AcZ,Tmp,GyX,GyY,GyZ;

int minVal=265; int maxVal=402;

double x; double y; double z;
Servo myservo;  // create servo object to control a servo

int pos = 0;    // variable to store the servo position

MPU6050 mpu;
int16_t ax, ay, az;
int16_t gx, gy, gz;

struct MyData {
  byte X;
  byte Y;
  byte Z;
};

MyData data;



void setup() {
    Serial.begin(9600);
    pinMode(trig, OUTPUT);
    pinMode(echo, INPUT);
  pinMode(enA, OUTPUT);
  pinMode(Ain1, OUTPUT);
  pinMode(Ain2, OUTPUT);

  digitalWrite(Ain1, LOW);
  digitalWrite(Ain2, LOW);

  pinMode(enB, OUTPUT);
  pinMode(Bin1, OUTPUT);
  pinMode(Bin2, OUTPUT);

  digitalWrite(Bin1, LOW);
  digitalWrite(Bin2, LOW);
  
  myservo.attach(11);  // attaches the servo on pin 9 to the servo object

  Wire.begin();
  mpu.initialize();
  pinMode(11, OUTPUT);
  Wire.beginTransmission(MPU_addr);
  Wire.write(0x6B);
  Wire.write(0);
  Wire.endTransmission(true);

  IR.enableIRIn();
}


void armnormal(){

  delay(30); // we might need to delay less uwu
  for (pos = 125; pos >= 0; pos -= 1) { // goes from 125 degrees to 0 degrees
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
    delay(30);                       // waits 30ms for the servo to reach the position
  }
  myservo.write(pos);
  delay(30);

}
void movearm(){
  
  for (pos = 0; pos <= 125; pos += 1) { // goes from 0 degrees to 125 degrees
    // in steps of 1 degree
    myservo.write(pos);              // tell servo to go to position in variable 'pos'
    delay(30);                       // waits ms for the servo to reach the position
  }
}

void stopp(){
    analogWrite(enA, 0);
    digitalWrite(Ain1, HIGH);
    digitalWrite(Ain2, LOW);
    analogWrite(enB, 0);
    digitalWrite(Bin1, HIGH);
    digitalWrite(Bin2, LOW);
    delay(100);
  }

void forward() {
  analogWrite(enA, 255);

  digitalWrite(Ain1, HIGH);
  digitalWrite(Ain2, LOW);

  analogWrite(enB, 255);

  digitalWrite(Bin1, LOW);
  digitalWrite(Bin2, HIGH);

  //delay(100);
  
}

void backwards() {
    analogWrite(enA, 255);
    digitalWrite(Ain1, LOW);
    digitalWrite(Ain2, HIGH);
    analogWrite(enB, 255);
    digitalWrite(Bin1, HIGH);
    digitalWrite(Bin2, LOW);
    //delay(100);
}

void sharpturnleft(){
    
    analogWrite(enA, 255);
    digitalWrite(Ain1, HIGH);
    digitalWrite(Ain2, LOW);
    /*analogWrite(enB, 255);
    digitalWrite(Bin1, HIGH);
    digitalWrite(Bin2, LOW);
    delay(100);*/
}

void sharpturnright(){
    
    analogWrite(enA, 255);
    digitalWrite(Ain1, LOW);
    digitalWrite(Ain2, HIGH);
    /*analogWrite(enB, 255);
    digitalWrite(Bin1, LOW);
    digitalWrite(Bin2, HIGH);
    delay(100);*/
}



void remotee(){    
  
  if (IR.decode()){

      if (IR.decodedIRData.decodedRawData == 3877175040){
          Serial.println("forward!");
          forward();
      }
      else if (IR.decodedIRData.decodedRawData == 2907897600){
          Serial.println("backward!");
          backwards();
      }
      else if (IR.decodedIRData.decodedRawData == 4144561920){
          Serial.println("sharp left!");
          sharpturnleft();
      }
      else if (IR.decodedIRData.decodedRawData == 2774204160){
          Serial.println("sharp right!");
          sharpturnright();
          
      }

      else {
        Serial.println(IR.decodedIRData.decodedRawData);
        Serial.println("stopp!");
        stopp();
    }
    IR.resume();
    delay(200);
  }}

void loop() {

Wire.beginTransmission(MPU_addr);
Wire.write(0x3B);
Wire.endTransmission(false);
Wire.requestFrom(MPU_addr,14,true);
AcX=Wire.read()<<8|Wire.read();
AcY=Wire.read()<<8|Wire.read();
AcZ=Wire.read()<<8|Wire.read();
int xAng = map(AcX,minVal,maxVal,-90,90);
int yAng = map(AcY,minVal,maxVal,-90,90);
int zAng = map(AcZ,minVal,maxVal,-90,90);

x= RAD_TO_DEG * (atan2(-yAng, -zAng)+PI);
y= RAD_TO_DEG * (atan2(-xAng, -zAng)+PI);
z= RAD_TO_DEG * (atan2(-yAng, -xAng)+PI);

/*Serial.print("AngleX= "); Serial.println(x);

Serial.print("AngleY= "); Serial.println(y);

Serial.print("AngleZ= "); Serial.println(data.Z); 
Serial.println("-----------------------------------------");
delay(400);*/

remotee();

    digitalWrite(trig, LOW);
    delayMicroseconds(2);
    digitalWrite(trig, HIGH);
    delayMicroseconds(10);
    digitalWrite(trig, LOW);
    int duration = pulseIn(echo,HIGH);
    int distance = (duration*0.0343)/2;
    delay(50);
    
    if (distance < 15){
      stopp();
      Serial.println("obstacle!");
    }
  
  mpu.getMotion6(&ax, &ay, &az, &gx, &gy, &gz);
  data.X = map(ax, -17000, 17000, 0, 255 ); // X axis data
  data.Y = map(ay, -17000, 17000, 0, 255); 
  data.Z = map(az, -17000, 17000, 0, 255);  // Y axis data
  delay(50);

  if (data.Z < 10 && data.Z >35){movearm();
  armnormal();}

  }
